package com.indigitall.indigitall_flutter_plugin.utils

import com.indigitall.android.customer.models.Customer
import com.indigitall.android.customer.models.CustomerField
import org.json.JSONArray
import org.json.JSONException

object CustomerParse {
    private val CALLBACK_CUSTOMER = "callbackCustomer"
    fun mapFromCustomer(customer: Customer): Map<String, Map<*,*>> {
        val MAP_ID = "id"
        val MAP_CUSTOMER_ID = "customerId"
        val MAP_APPLICATION_ID = "applicationId"
        val MAP_CREATED_AT = "createdAt"
        val MAP_UPDATED_AT = "updatedAt"

        val map: MutableMap<String, String> = HashMap()
        try {
            customer.id?.let { map[MAP_ID] = it.toString() }
            customer.customerId?.let { map[MAP_CUSTOMER_ID] = it.toString() }
            customer.createdAt?.let { map[MAP_CREATED_AT] = it.toString() }
            customer.applicationId?.let { map[MAP_APPLICATION_ID] = it.toString() }
            customer.updatedAt?.let { map[MAP_UPDATED_AT] = it.toString() }

        } catch (ex: Exception) {
            ex.printStackTrace()
        }
        val customerMap: MutableMap<String, Map<*,*>> = HashMap()
        customerMap[CALLBACK_CUSTOMER] = map
        return customerMap
    }

    fun listFromCustomerArray(customerFields: ArrayList<CustomerField>): ArrayList<Map<*, *>> {
        val list = arrayListOf<Map<*, *>>()
        for (i in customerFields.indices){
            list.add(mapFromCustomerFields(customerFields[i]))
        }
        return list
    }

    fun mapFromCustomerFields(field: CustomerField): Map<*, *> {
        val map : MutableMap<String, String> = HashMap()
        field.customerFieldKey?.let{
            if (field.customerFieldValue != null){
                map[it] = field.customerFieldValue!!
            }else{
                map[it] = ""
            }
        }
        return map
    }

    fun customerFieldToMap(keyString: String, value: ArrayList<Map<*, *>>): Map<*, *>{
        val map: MutableMap<String, ArrayList<Map<*, *>>> = HashMap()
        map[keyString] = value
        return map
    }

    fun parseCustomerArray(params: JSONArray?): ArrayList<String> {
        var fields = arrayListOf<String>()
        try {
            params?.let{
                if (it.length() > 0) {
                    for (i in 0 until it.length()) {
                        fields.add(it.getString(i))
                    }
                }
            }
        } catch (ex: JSONException) {
            ex.printStackTrace()
        }
        return fields
    }
}