#import "IndigitallFlutterPlugin.h"
#import "IndigitallInboxFlutterPlugin.h"
#import "IndigitallInAppFlutterPlugin.h"
#import "IndigitallCustomerFlutterPlugin.h"
#import <Indigitall/NotificationHandler.h>
#import "IndigitallPushFParse.h"
@implementation IndigitallFlutterPlugin

static FlutterResult tokenRefreshResult;

+ (FlutterResult) tokenRefreshResult {
    return tokenRefreshResult;
}

+ (void) setTokenRefreshResult: (FlutterResult) result {
    tokenRefreshResult = result;
}

static FlutterResult pushResult;

+ (FlutterResult) pushResult {
    return pushResult;
}

+ (void) setPushResult: (FlutterResult) result {
    pushResult = result;
}

static IndigitallFlutterPlugin *indigitallFlutterPlugin;

+ (IndigitallFlutterPlugin *) indigitallFlutterPlugin {
    return indigitallFlutterPlugin;
}

NSString *INIT = @"initialize";
NSString *DEVICE_ENABLE = @"deviceEnable";
NSString *DEVICE_DISABLED = @"deviceDisable";
NSString *TOPICS_LIST = @"topicsList";
NSString *TOPICS_SUBSCRIBE = @"topicsSubscribe";
NSString *TOPICS_UNSUBSCRIBE = @"topicsUnsubscribe";
NSString *SET_EXTERNAL_CODE = @"setExternalCode";
NSString *SEND_CUSTOM_EVENT = @"sendCustomEvent";
NSString *PACKAGE_NAME = @"packageName";
NSString *GET_PUSH = @"getPush";
NSString *IS_INDIGITALL_PUSH_NOTIFICATION = @"isIndigitallPushNotification";
NSString *GET_TOKEN = @"getToken";
NSString *ON_MESSAGE_RECEIVED = @"onMessageReceived";
NSString *LOG_IN = @"logIn";
NSString *LOG_OUT = @"logOut";

NSString *GET_INAPP = @"getInApp";
NSString *INAPP_GET_HTML = @"inAppGetHtml";
NSString *ON_CLICK = @"onClick";
NSString *EVENT_PRINT = @"eventPrintInAppRequest";
NSString *INAPP_TOPICS_LIST = @"inAppTopicsList";
NSString *INAPP_TOPICS_SUBSCRIBE = @"inAppTopicsSubscribe";
NSString *INAPP_TOPICS_UNSUBSCRIBE = @"inAppTopicsUnsubscribe";
NSString *SHOW_POP_UP = @"showPopUp";
NSString *ACTION_ADD_NEW_INAPP_TO_DISMISS_FOREVER = @"addNewInAppToDismissForever";

NSString *ACTION_GET_INBOX_COUNT = @"getMessageCount";
NSString *ACTION_GET_INBOX = @"getInbox";
NSString *ACTION_GET_NEXT_PAGE = @"getNextPage";
NSString *ACTION_MASSIVE_EDIT_NOTIFICATIONS = @"massiveEditNotificationsWithSendingIdsList";
NSString *ACTION_INFO_NOTIFICATION = @"getInfoFromNotificationWithSendingId";
NSString *ACTION_MODIFY_STATUS_NOTIFICATION = @"modifyStatusFromNotificationWithSendingId";
NSString *ACTION_GET_AUTH_CONFIG = @"getAuthConfig";

NSString *ACTION_GET_CUSTOMER = @"getCustomer";
NSString *ACTION_GET_CUSTOMER_INFORMATION = @"getCustomerInformation";
NSString *ACTION_UPDATE_VALUE_CUSTOMER_FIELDS = @"assignOrUpdateValueToCustomerFields";
NSString *ACTION_DELETE_VALUES_CUSTOMER_FIELDS = @"deleteValuesFromCustomerFields";
NSString *ACTION_LINK = @"link";
NSString *ACTION_UNLINK = @"unlink";

NSString *CALLBACK_ON_INDIGITALL_INITIALIZED = @"callbackOnIndigitallInitialized";
NSString *CALLBACK_DEVICE_ENABLE = @"callbackDeviceEnabled";
NSString *CALLBACK_DEVICE_DISABLE = @"callbackDeviceDisEnabled";
NSString *CALLBACK_TOPIC_LIST = @"callbackTopicList";
NSString *CALLBACK_TOPIC_SUBSCRIBE = @"callbackTopicSubscribe";
NSString *CALLBACK_TOPIC_UNSUBSCRIBE = @"callbackTopicUnsubscribe";
NSString *CALLBACK_EXTERNAL_CODE = @"callbackExternalCode";
NSString *CALLBACK_SEND_CUSTOM_EVENT = @"callbackSendCustomEvent";
NSString *CALLBACK_LOGIN = @"callbackLogin";
NSString *CALLBACK_LOGOUT = @"callbackLogout";

Inbox *myInbox;
FlutterMethodChannel *channel;

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
//  [SwiftIndigitallFlutterPlugin registerWithRegistrar:registrar];
    channel = [FlutterMethodChannel methodChannelWithName:@"indigitall_flutter_plugin" binaryMessenger:registrar.messenger];
    [channel setMethodCallHandler:^(FlutterMethodCall * _Nonnull call, FlutterResult  _Nonnull result) {
        if ([call.method isEqual:INIT]){
            [self initialize:call.arguments result:result];
        } else if ([call.method isEqual:DEVICE_ENABLE]){
            [self deviceEnable:result];
        } else if ([call.method isEqual:DEVICE_DISABLED]){
            [self deviceDisable:result];
        } else if ([call.method isEqual:TOPICS_LIST]){
            [self topicsList:result];
        } else if ([call.method isEqual:TOPICS_SUBSCRIBE]){
            [self topicsSubscribe:call.arguments result:result];
        } else if ([call.method isEqual:TOPICS_UNSUBSCRIBE]){
            [self topicsUnsubscribe:call.arguments result:result];
        } else if ([call.method isEqual:SET_EXTERNAL_CODE]){
            [self setExternalCode:call.arguments result:result];
        } else if ([call.method isEqual:SEND_CUSTOM_EVENT]){
            [self sendCustomEvent:call.arguments result:result];
        } else if ([call.method isEqual:PACKAGE_NAME]){
            [self packageName:result];
        } else if ([call.method isEqual:GET_TOKEN]){
            [self getToken:result];
        } else if ([call.method isEqual:IS_INDIGITALL_PUSH_NOTIFICATION]){
            [self isIndigitallPushNotification:call.arguments result:result];
        } else if ([call.method isEqual:GET_PUSH]){
            [self getPush:result];
        } else if ([call.method isEqual:LOG_IN]){
            [self logIn:call.arguments result:result];
        } else if ([call.method isEqual:LOG_OUT]){
            [self logOut:result];
        } else if ([GET_INAPP isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin getInAppModelWithParams:call.arguments result:result];
        } else if ([INAPP_GET_HTML isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin inAppGetHtmlWithUrl:call.arguments result:result];
        } else if ([ON_CLICK isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin onClickWithParams:call.arguments result:result];
        } else if ([EVENT_PRINT isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin eventPrintInAppRequestWithParams:call.arguments result:result];
        } else if ([TOPICS_LIST isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin topicsListWithParams:call.arguments result:result];
        } else if ([TOPICS_SUBSCRIBE isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin topicsSubscribeWithParams:call.arguments result:result];
        } else if ([TOPICS_UNSUBSCRIBE isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin topicsUnsubscribeWithParams:call.arguments result:result];
        } else if ([SHOW_POP_UP isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin showPopUpWithParams:call.arguments result:result];
        } else if ([ACTION_ADD_NEW_INAPP_TO_DISMISS_FOREVER isEqualToString:call.method]) {
            [IndigitallInAppFlutterPlugin addNewInAppToDismissForeverWithParams:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_GET_INBOX_COUNT]) {
            [[IndigitallInboxFlutterPlugin alloc] getInboxMessagesCountWithArguments:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_GET_INBOX]) {
            [[IndigitallInboxFlutterPlugin alloc]  getInboxWithArguments:call.arguments success:^(Inbox *inbox) {
                myInbox = inbox;
            } result:result];
        } else if ([call.method isEqual:ACTION_GET_NEXT_PAGE]) {
            [[IndigitallInboxFlutterPlugin alloc]  getNextPageWithArguments:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_MASSIVE_EDIT_NOTIFICATIONS]) {
            [[IndigitallInboxFlutterPlugin alloc]  massiveEditNotificationsWithSendingIdsList:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_INFO_NOTIFICATION]) {
            [[IndigitallInboxFlutterPlugin alloc]  getInfoFromNotificationWithSendingId:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_MODIFY_STATUS_NOTIFICATION]) {
            [[IndigitallInboxFlutterPlugin alloc]  modifyStatusFromNotificationWithSendingId:call.arguments inbox:myInbox result:result];
        } else if ([call.method isEqual:ACTION_GET_AUTH_CONFIG]) {
            [[IndigitallInboxFlutterPlugin alloc] setAuth:call.arguments];
        } else if ([call.method isEqual:ACTION_GET_CUSTOMER]) {
            [IndigitallCustomerFlutterPlugin getCustomer:result];
        } else if ([call.method isEqual:ACTION_GET_CUSTOMER_INFORMATION]) {
            [IndigitallCustomerFlutterPlugin getCustomerInformation:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_LINK]) {
            [IndigitallCustomerFlutterPlugin link:call.arguments result:result];
        } else if ([call.method isEqual:ACTION_UNLINK]) {
            [Indigitall logOutWithSuccess:^(INDevice * _Nonnull device) {
                [IndigitallCustomerFlutterPlugin unlink:call.arguments result:result];
            } onError:^(INError * _Nonnull error) {
                [IndigitallPushFParse jsonFromError: error withResult:result];
            }];
        } else if ([call.method isEqual:ACTION_UPDATE_VALUE_CUSTOMER_FIELDS]) {
            [IndigitallCustomerFlutterPlugin assignOrUpdateValueToCustomerFields:call.arguments result:result];
          
        } else if ([call.method isEqual:ACTION_DELETE_VALUES_CUSTOMER_FIELDS]) {
            [IndigitallCustomerFlutterPlugin deleteValuesFromCustomerFields:call.arguments result:result];
        }
    }];
}


+ (void) initialize: (NSDictionary *)params result: (FlutterResult _Nonnull)result {
      NSString *appKey = params[@"appKey"];
    if (appKey != nil) [INDefaults setAppKey: appKey];
      NSLog(@"params: %@",params);
        PushConfig *config = [[PushConfig alloc]init];
        config.appKey = appKey;

      config.pushPermissionMode = automatic;
      if(params[@"requestLocation"]){
          config.locationPermissionMode = automatic;
      }else{
          config.locationPermissionMode = manual;
      }

      if (params[@"wifiFilterEnabled"]){
          config.wifiFilterEnabled = params[@"wifiFilterEnabled"];
      }

      if (params[@"urlDeviceApi"]) config.domain = params[@"urlDeviceApi"];
    
      if (params[@"urlInboxApi"]) config.domainInbox = params[@"urlInboxApi"];

      [config setProductName:params[@"productName"]];
      [config setProductVersion:params[@"productVersion"]];
      
      [Indigitall askNotificationPermission];
      [Indigitall initializeWithConfig:config onIndigitallInitialized:^(NSArray<INPermissions *> * _Nonnull permissions, INDevice * _Nonnull device) {
            [IndigitallPushFParse jsonFromDevice:device withKey:CALLBACK_ON_INDIGITALL_INITIALIZED withResult:result];
          } onErrorInitialized:^(INError * _Nonnull onError) {
              [IndigitallPushFParse jsonFromError:onError withResult:result];
      }];
      
  }

+ (void) packageName: (FlutterResult _Nonnull)result{
    NSString *bundleIdentifier = [[NSBundle mainBundle] bundleIdentifier];
    [IndigitallPushFParse resultFromString:bundleIdentifier withAction:PACKAGE_NAME withResult:result];
}

+ (void) deviceEnable: (FlutterResult _Nonnull)result {
    
    [Indigitall enableDeviceWithOnSuccess:^(INDevice * _Nonnull device) {
        [IndigitallPushFParse jsonFromDevice:device withKey:CALLBACK_DEVICE_ENABLE withResult:result];
    } onError:^(INError * _Nonnull error) {
        [IndigitallPushFParse jsonFromError: error withResult:result];
    }];
}

+ (void) deviceDisable: (FlutterResult _Nonnull)result {
    
    [Indigitall disableDeviceWithOnSuccess:^(INDevice * _Nonnull device) {
        [IndigitallPushFParse jsonFromDevice:device withKey:CALLBACK_DEVICE_DISABLE withResult:result];
    } onError:^(INError * _Nonnull error) {
        [IndigitallPushFParse jsonFromError: error withResult:result];
    }];
}

+ (void) topicsList: (FlutterResult _Nonnull)result{
    
    [Indigitall topicsListWithOnSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
        [IndigitallPushFParse resultFromTopic:[IndigitallPushFParse jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_LIST withResult:result];
    } onError:^(INError * _Nonnull error) {
        [IndigitallPushFParse jsonFromError: error withResult:result];
    }];
}

+ (void) topicsSubscribe: (id)object result: (FlutterResult _Nonnull)result{
    if (![object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray* params = object;
        NSMutableArray<INTopic *>* topicsList = [[NSMutableArray alloc]init];
        for (int i = 0; i < params.count; i++) {
           INTopic *topic = [[INTopic alloc]init:params[i]];
           topicsList[i] = topic;
        }

        [Indigitall topicsSubscribeWithTopic:topicsList onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
            [IndigitallPushFParse resultFromTopic:[IndigitallPushFParse jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_SUBSCRIBE withResult:result];
        } onError:^(INError * _Nonnull error) {
            [IndigitallPushFParse jsonFromError: error withResult:result];
        }];
       
    }else if ([object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray<NSString *>* params = object;
         [Indigitall topicsSubscribeWithArrayString:params onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
             [IndigitallPushFParse resultFromTopic:[IndigitallPushFParse jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_SUBSCRIBE withResult:result];
         } onError:^(INError * _Nonnull error) {
            [IndigitallPushFParse jsonFromError: error withResult:result];
         }];
    }else{
        [IndigitallPushFParse jsonFromError: [[INError alloc]initWithErrorCode:1400 descriptionMessage:@"topicsSubscribe is not defined"] withResult:result];
    }
}

+ (void) topicsUnsubscribe: (id)object result: (FlutterResult _Nonnull)result{
    if (![object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray* params = object;
        NSMutableArray<INTopic *>* topicsList = [[NSMutableArray alloc]init];
        for (int i = 0; i < params.count; i++) {
          INTopic *topic = [[INTopic alloc]init:[params[i] mutableCopy]];
          topicsList[i] = topic;
        }
        [Indigitall topicsUnSubscribeWithTopic:topicsList onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
            [IndigitallPushFParse resultFromTopic:[IndigitallPushFParse jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_UNSUBSCRIBE withResult:result];
        } onError:^(INError * _Nonnull error) {
           [IndigitallPushFParse jsonFromError: error withResult:result];
        }];
    }else if ([object isKindOfClass:[NSArray<NSString *> class]]){
        NSArray<NSString *>* params = object;
        [Indigitall topicsUnSubscribeWithArrayString:params onSuccess:^(NSArray<INTopic *> * _Nonnull topics) {
            [IndigitallPushFParse resultFromTopic:[IndigitallPushFParse jsonArrayFromTopics:topics] key:CALLBACK_TOPIC_UNSUBSCRIBE withResult:result];
        } onError:^(INError * _Nonnull error) {
            [IndigitallPushFParse jsonFromError: error withResult:result];
        }];
    }else{
        [IndigitallPushFParse jsonFromError: [[INError alloc]initWithErrorCode:1400 descriptionMessage:@"topicsUnsubscribe is not defined"] withResult:result];
    }
}

+ (void) setExternalCode: (id )object result: (FlutterResult _Nonnull)result {
    NSString *params = object;
    if (params != nil){
        [Indigitall setExternalCode:params onSuccess:^(INDevice * _Nonnull device) {
            [IndigitallPushFParse jsonFromDevice:device withKey:CALLBACK_EXTERNAL_CODE withResult:result];
        } onError:^(INError * _Nonnull error) {
            [IndigitallPushFParse jsonFromError: error withResult:result];
        }];
    }else{
        [IndigitallPushFParse jsonFromError: [[INError alloc]initWithErrorCode:1800 descriptionMessage:@"setExternalCode is not defined"] withResult:result];
    }
}

+ (void) sendCustomEvent: (NSDictionary *)params result: (FlutterResult _Nonnull)result{
    NSString *event;
    NSDictionary *customData;
    if (params[@"event"]) event = params[@"event"];
    if ([params[@"customData"] isKindOfClass:[NSString class]]){
        NSData *data = [params[@"customData"] dataUsingEncoding:NSUTF8StringEncoding];
        customData = [NSJSONSerialization JSONObjectWithData:data options:0 error:nil];
    }else{
        if (params[@"customData"]) customData = params[@"customData"];
    }
    
    if (params != nil){
        [Indigitall sendCustomEvent:event customData:customData onSuccess:^{
            [IndigitallPushFParse resultFromString: @"event success" withAction: CALLBACK_SEND_CUSTOM_EVENT withResult:result];
        } onError:^(INError * _Nonnull error) {
            [IndigitallPushFParse jsonFromError: error withResult:result];
        }];
    }else{
        [IndigitallPushFParse jsonFromError: [[INError alloc]initWithErrorCode:1600 descriptionMessage:@"sendCustomEvent is not defined"] withResult:result];
    }
}

+ (void) getPush: (FlutterResult _Nonnull)result{
    self.pushResult = result;
}

+ (void) handleTapNotification: (UNNotificationResponse*_Nonnull) response {
    NSDictionary*userinfo = response.notification.request.content.userInfo;
    INPush *push = [NotificationHandler getPushObject: userinfo];
    if (push != nil && push.appKey != nil && self.pushResult != nil) {
        NSMutableDictionary *dict = [NSMutableDictionary new];
        [dict setValue:userinfo forKey:@"callbackgetPush"];
        self.pushResult([dict copy]);
    }
}

+ (void) getToken: (FlutterResult _Nonnull)result {
    NSString * token = [INPushDefaults getPushToken];
    if (token != nil) {
        //[self resul]
        NSMutableDictionary *dict = [NSMutableDictionary new];
        [dict setValue:token forKey:@"token"];
        result([dict copy]);
    } else {
        self.tokenRefreshResult = result;
    }
}

+ (void)sendNotification:(NSDictionary*)userInfo {
    NSMutableDictionary *dict = [NSMutableDictionary new];
    [dict setValue:userInfo forKey:@"notification"];
    [channel invokeMethod:ON_MESSAGE_RECEIVED arguments:dict];
}

+ (void)sendToken:(NSData*)token {
    if (self.tokenRefreshResult != nil) {
        NSUInteger length = token.length;
        if (length == 0) {
            return;
        }
        const unsigned char *buffer = token.bytes;
        NSMutableString *pushToken  = [NSMutableString stringWithCapacity:(length * 2)];
        for (int i = 0; i < length; ++i) {
            [pushToken appendFormat:@"%02x", buffer[i]];
        }
        NSMutableDictionary *dict = [NSMutableDictionary new];
        [dict setValue:token forKey:@"token"];
        self.tokenRefreshResult([dict copy]);
    }
}

+ (void) isIndigitallPushNotification: (NSDictionary *)params result: (FlutterResult _Nonnull)result {
    if (params != nil) {
        INPush *push = [NotificationHandler getPushObject:params];
        if (push != nil && push.appKey != nil) {
            result(@YES);
        } else {
            result(@NO);
        }
    }
}


+ (void) logIn: (id)object result: (FlutterResult _Nonnull)result{
    NSString *params = object;
    if (params != nil){
        [Indigitall logInWithId:params onSuccess:^(INDevice * _Nonnull device) {
            [IndigitallPushFParse jsonFromDevice:device withKey:CALLBACK_LOGIN withResult:result];
        } onError:^(INError * _Nonnull error) {
            [IndigitallPushFParse jsonFromError: error withResult:result];
        }];
    }else{
        [IndigitallPushFParse jsonFromError:  [[INError alloc]initWithErrorCode:1500 descriptionMessage:@"logIn is not defined"] withResult:result];
    }
}

+ (void) logOut: (FlutterResult _Nonnull)result{
    [Indigitall logOutWithSuccess:^(INDevice * _Nonnull device) {
        [IndigitallPushFParse jsonFromDevice:device withKey:CALLBACK_LOGOUT withResult:result];
    } onError:^(INError * _Nonnull error) {
        [IndigitallPushFParse jsonFromError: error withResult:result];
    }];
}



@end
