//
//  IndigitallCustomerParse.m
//  indigitall_flutter_plugin
//
//  Created by indigitall on 18/1/23.
//

#import "IndigitallCustomerFParse.h"

@implementation IndigitallCustomerFParse

+ (NSDictionary *) jsonFromCustomer: (INCustomer *) customer{
    NSMutableDictionary *obj = [[NSMutableDictionary alloc]init];
    if (customer != nil) {
        obj = [@{
            @"id" : customer._id ?: @"",
            @"customerId": customer._id ?: @"",
            @"applicationId" : customer.applicationId ?: @"",
            @"createdAt": customer.createdAt ?: @"",
            @"updatedAt": customer.updatedAt ?: @""
        } mutableCopy];
    }
    return [obj copy];
}

+ (NSArray<NSDictionary *> *) jsonFromCustomerFields: (NSArray<INCustomerField *>*)customerFields{
    NSMutableArray<NSDictionary *> *array = [[NSMutableArray alloc]init];
    for (int i = 0; i < customerFields.count; i++) {
        if (customerFields[i].customerFieldKey && customerFields[i].customerFieldValue){
            NSMutableDictionary *obj = [[NSMutableDictionary alloc]init];
            obj = [@{
                customerFields[i].customerFieldKey : customerFields[i].customerFieldValue,
            } mutableCopy];
            [array addObject:[obj copy]];
        }
    }
    return [array copy];
}

+ (void) jsonFromError: (INError *)error withResult: (FlutterResult _Nonnull) result {
    result([FlutterError errorWithCode:[NSString stringWithFormat:@"%u",error.errorCode] message:error.message details:nil]);
}
@end
